// 创建ObsClient实例
import ObsClient from 'esdk-obs-browserjs';
const obsClient = new ObsClient({
    access_key_id: "EE4MAFWH4YLQSQF7NNIP",
    secret_access_key: "Dq9giqqwZoX77dqSIzhA1Yhhe9tarA3LRBGBF4eO",
    server : 'https://obs.cn-east-3.myhuaweicloud.com',
    timeout : 1000
});
let mainId = sessionStorage.getItem('_mainId') ? sessionStorage.getItem('_mainId') : "";
let IDX = 256, HEX = [], SIZE = 256, BUFFER;
while (IDX--) HEX[IDX] = (IDX + 256).toString(16).substring(1);
function uid(len) {
    let i = 0, tmp = (len || 11);
    if (!BUFFER || ((IDX + tmp) > SIZE * 2)) {
        for (BUFFER = '', IDX = 0; i < SIZE; i++) {
            BUFFER += HEX[Math.random() * 256 | 0];
        }
    }

    return BUFFER.substring(IDX, IDX++ + tmp);
}

function dataFormat(fmt, date = new Date()) {
    const o = {
        "M+": date.getMonth() + 1, //月份
        "d+": date.getDate(), //日
        "h+": date.getHours(), //小时
        "m+": date.getMinutes(), //分
        "s+": date.getSeconds(), //秒
        "q+": Math.floor((date.getMonth() + 3) / 3), //季度
        "S": date.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (const k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}
async function putObject(file,callback){
    let fileUrl = ''
    let objName = (process.env.VUE_APP_ENV === 'development' ? 'dev_' : 'pro_') + file.name;
    let fileName = "front-oss/" + mainId + '/' + dataFormat("yyyy/MM/dd/hh/mm/") + uid(32) + "/" + objName;
    await obsClient.putObject({
        Bucket: 'askbot-uat',
        Key : fileName,
        SourceFile : file,
        ACL : obsClient.enums.AclPublicRead,
        ProgressCallback: callback
    }).then(function(result) {
        if(result.CommonMsg.Status < 300){
            console.log('Create object:' + JSON.stringify(result) + ' successfully!\n',process.env.VUE_APP_ENV);
            let domain = process.env.VUE_APP_ENV ==='development' ? 'https://askbot-uat.obs.cn-east-3.myhuaweicloud.com/' : ''
            fileUrl = {
                url: domain + fileName,
                name:file.name
            }
        }
    });
    return fileUrl
}

export {
    putObject
}