import Vue from 'vue'
import App from './App.vue'
import VueResource from 'vue-resource'
import ElementUI from 'element-ui';
import { requestUrl } from './api/index';
import { utils } from '../src/components/utils/index';
// /*import 'element-ui/lib/theme-chalk/index.css';*/
import './assets/theme/index.css'
import 'video.js/dist/video-js.css'
import Vant from 'vant';
import 'vant/lib/index.css';

/*import VConsole from 'vconsole'
const vConsole = new VConsole();
Vue.use(vConsole);*/
import $ from 'jquery'
Vue.prototype._$ = $;
Vue.use(Vant);
Date.prototype.Format = function (fmt) { //author: meizz
  var o = {
    "M+": this.getMonth() + 1, //月份
    "d+": this.getDate(), //日
    "h+": this.getHours(), //小时
    "m+": this.getMinutes(), //分
    "s+": this.getSeconds(), //秒
    "q+": Math.floor((this.getMonth() + 3) / 3), //季度
    "S": this.getMilliseconds() //毫秒
  };
  if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
  for (var k in o)
    if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
  return fmt;
}
Vue.config.productionTip = false
Vue.use(VueResource)
Vue.use(ElementUI)
//导入图片预览viewer组件以及css
import Viewer from 'v-viewer'
import 'viewerjs/dist/viewer.css'
Vue.use(Viewer, {
  defaultOptions: {
    zIndex: 9999,//解决图片放大的层级问题
  }
});
// setDeafaults配置
Viewer.setDefaults({
  Options: { "inline": true, "button": true, "navbar": true, "title": true, "toolbar": true, "tooltip": true, "movable": true, "zoomable": true, "rotatable": true, "scalable": true, "transition": true, "fullscreen": true, "keyboard": true, "url": "data-source" }
})



Vue.prototype.requestUrl = requestUrl;
Vue.prototype.utils = utils;

new Vue({
  render: h => h(App),
}).$mount('#app')
