const webpack = require('webpack')


module.exports = {
    // 修改的配置
    // 将baseUrl: '/api',改为baseUrl: '/',
    devServer: {
        port: '8082',   // 指定打开浏览器的端口号
        proxy: {
            '/api/': {
                // target: 'http://test.open.abitai.com:9001',
                target: 'http://test.open.askbot.cn:32001',
                changeOrigin: true,
                ws: true,
                pathRewrite: {
                    '^/api': '/'
                }
            },
            '/open/': {
                target: 'http://new-test.guoranbot.com:32001',
                changeOrigin: true,
                pathRewrite: {
                    '^/open': '/'
                }
            },
            '/order-api': {
                target: 'http://master.test.askbot.cn:32022',
                /*target:'http://new-test.guoranbot.com:30672',*/
                changeOrigin: true,
                ws: true,
                pathRewrite: {
                    '^/order-api': '/'
                }
            },
            '/knowledge-api/': {
                target: 'http://master.test.askbot.cn:30202',
                changeOrigin: true,
                ws: true,
                pathRewrite: {
                    '^/knowledge-api': '/'
                }
            },
        },
    },
    configureWebpack: {
        externals: {
            // 'vue': 'Vue',
            // 属性名称 element-ui, 表示遇到 import xxx from 'element-ui' 这类引入 'element-ui'的，
            // 不去 node_modules 中找，而是去找 全局变量 ELEMENT
            // 'element-ui': 'ELEMENT',
            // 'vant': 'Vant',
        },
    },

};